from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, Int, String, File

Filter_Abund_Single_Py_V0_1_0 = CommandToolBuilder(tool="filter_abund_single.py", base_command=["filter-abund-single.py"], inputs=[ToolInput(tag="in_info", input_type=Boolean(optional=True), prefix="--info", doc=InputDocumentation(doc="print citation information")), ToolInput(tag="in_k_size", input_type=Int(optional=True), prefix="--ksize", doc=InputDocumentation(doc="k-mer size to use (default: 32)")), ToolInput(tag="in_unique_km_ers", input_type=Int(optional=True), prefix="--unique-kmers", doc=InputDocumentation(doc="approximate number of unique kmers in the input set\n(default: 0)")), ToolInput(tag="in_fp_rate", input_type=String(optional=True), prefix="--fp-rate", doc=InputDocumentation(doc="Override the automatic FP rate setting for the current\nscript (default: None)")), ToolInput(tag="in_max_memory_usage", input_type=Int(optional=True), prefix="--max-memory-usage", doc=InputDocumentation(doc="maximum amount of memory to use for data structure\n(default: None)")), ToolInput(tag="in_small_count", input_type=Boolean(optional=True), prefix="--small-count", doc=InputDocumentation(doc="Reduce memory usage by using a smaller counter for\nindividual kmers. (default: False)")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="--threads", doc=InputDocumentation(doc="Number of simultaneous threads to execute (default: 1)")), ToolInput(tag="in_cut_off", input_type=Int(optional=True), prefix="--cutoff", doc=InputDocumentation(doc="Trim at k-mers below this abundance. (default: 2)")), ToolInput(tag="in_variable_coverage", input_type=Boolean(optional=True), prefix="--variable-coverage", doc=InputDocumentation(doc="Only trim low-abundance k-mers from sequences that\nhave high coverage. (default: False)")), ToolInput(tag="in_normalize_to", input_type=Int(optional=True), prefix="--normalize-to", doc=InputDocumentation(doc="Base the variable-coverage cutoff on this median k-mer\nabundance. (default: 20)")), ToolInput(tag="in_save_graph", input_type=File(optional=True), prefix="--savegraph", doc=InputDocumentation(doc="If present, the name of the file to save the k-mer\ncountgraph to (default: )")), ToolInput(tag="in_outfile", input_type=File(optional=True), prefix="--outfile", doc=InputDocumentation(doc="Override default output filename and output trimmed\nsequences into a file with the given filename.\n(default: None)")), ToolInput(tag="in_force", input_type=File(optional=True), prefix="--force", doc=InputDocumentation(doc="Overwrite output file if it exists (default: False)")), ToolInput(tag="in_quiet", input_type=Boolean(optional=True), prefix="--quiet", doc=InputDocumentation(doc="Compress output using gzip (default: False)")), ToolInput(tag="in_bzip", input_type=Boolean(optional=True), prefix="--bzip", doc=InputDocumentation(doc="Compress output using bzip2 (default: False)"))], outputs=[ToolOutput(tag="out_outfile", output_type=File(optional=True), selector=InputSelector(input_to_select="in_outfile", type_hint=File()), doc=OutputDocumentation(doc="Override default output filename and output trimmed\nsequences into a file with the given filename.\n(default: None)")), ToolOutput(tag="out_force", output_type=File(optional=True), selector=InputSelector(input_to_select="in_force", type_hint=File()), doc=OutputDocumentation(doc="Overwrite output file if it exists (default: False)"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Filter_Abund_Single_Py_V0_1_0().translate("wdl", allow_empty_container=True)

